.386p					;386 instruction set enable
.model flat, stdCALL
include ..\common\crc32.asm
include ..\common\md5.asm
include ..\common\sha1.asm
include ..\common\sha-256.asm
include ..\common\sha-384.asm
include ..\common\sha-512.asm
include ..\common\ripemd-128.asm
include ..\common\ripemd-160.asm

Comment %
	VERIFYME
	CHECKME
%

;*******************************************************************
;*  DATA                                                           *
;*******************************************************************
         .data
;/* Encryption method */
 filename_crc32		db "checkme.crc32", 0		;index=0
 filename_md5		db "checkme.md5", 0		;index=1
 filename_ripemd128	db "checkme.ripemd128", 0	;index=2
 filename_ripemd160	db "checkme.ripemd160", 0	;index=3
 filename_sha160	db "checkme.sha160", 0		;index=4
 filename_sha256	db "checkme.sha256", 0		;index=5
 filename_sha384	db "checkme.sha384", 0		;index=6
 filename_sha512	db "checkme.sha512", 0		;index=7
 filename_extension	equ 8

 string_crc32		db "CRC-32", 0		;index=0
 string_md5		db "MD5", 0		;index=1
 string_ripemd128	db "RIPEMD-128", 0	;index=2
 string_ripemd160	db "RIPEMD-160", 0	;index=3
 string_sha160		db "SHA-160 (sha-1)", 0	;index=4
 string_sha256		db "SHA-256", 0		;index=5
 string_sha384		db "SHA-384", 0		;index=7
 string_sha512		db "SHA-512", 0		;index=6

 crypt_number = 8
 crypt_table	dd (offset filename_crc32), (offset string_crc32), (offset CRC32_Compute), (offset Dword1ToAscii)
		dd (offset filename_md5),   (offset string_md5),   (offset MD5_Compute),   (offset Dword4ToAscii)
		dd (offset filename_ripemd128),(offset string_ripemd128),(offset RIPEMD128_Compute),(offset Dword4ToAscii)
		dd (offset filename_ripemd160),(offset string_ripemd160),(offset RIPEMD160_Compute),(offset Dword5ToAscii)
		dd (offset filename_sha160),(offset string_sha160), (offset SHA_Compute),   (offset Dword5ToAscii)
		dd (offset filename_sha256),(offset string_sha256), (offset SHA256_Compute),(offset Pointer8ToAscii)
		dd (offset filename_sha384),(offset string_sha384), (offset SHA384_Compute),(offset Pointer12ToAscii)
		dd (offset filename_sha512),(offset string_sha512), (offset SHA512_Compute),(offset Pointer16ToAscii)
		dd 0	;stop mark
 crypt_current	dd 0			;contains the adresse to the right selected entry
 crypt_wsprintf	dd 0

 mask_wsprintf1	db "%08X",0									; 32-bit hash result
 mask_wsprintf2	db "%08X%08X%08X%08X",0								;128-bit hash result
 mask_wsprintf3	db "%08X%08X%08X%08X%08X",0							;160-bit hash result
 mask_wsprintf4	db "%08X%08X%08X%08X%08X%08X%08X%08X",0						;256-bit hash result
 mask_wsprintf5	db "%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X",0				;384-bit hash result
 mask_wsprintf6	db "%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X%08X",0		;512-bit hash result
IFDEF VERIFYME
tempbuffer2 equ	tempbuffer
ENDIF

;*******************************************************************
;*  CODE                                                           *
;*******************************************************************
         .code

Pointer12ToAscii	proc
	call	_wsprintfA, offset tempbuffer2, offset mask_wsprintf5, dword ptr [eax], dword ptr [eax+4], \
		dword ptr [eax+8], dword ptr [eax+0Ch], dword ptr [eax+10h], dword ptr [eax+14h], dword ptr [eax+18h], \
		dword ptr [eax+1Ch], dword ptr [eax+20h], dword ptr [eax+24h], dword ptr [eax+28h], dword ptr [eax+2Ch]
	add	esp, 38h
	ret
Pointer12ToAscii	endp

Pointer16ToAscii	proc
	call	_wsprintfA, offset tempbuffer2, offset mask_wsprintf6, dword ptr [eax], dword ptr [eax+4], \
		dword ptr [eax+8], dword ptr [eax+0Ch], dword ptr [eax+10h], dword ptr [eax+14h], dword ptr [eax+18h], \
		dword ptr [eax+1Ch], dword ptr [eax+20h], dword ptr [eax+24h], dword ptr [eax+28h], dword ptr [eax+2Ch], \
		dword ptr [eax+30h], dword ptr [eax+34h], dword ptr [eax+38h], dword ptr [eax+3Ch]
	add	esp, 48h
	ret
Pointer16ToAscii	endp

Pointer8ToAscii	proc
	call	_wsprintfA, offset tempbuffer2, offset mask_wsprintf4, dword ptr [eax], dword ptr [eax+4], \
		dword ptr [eax+8], dword ptr [eax+0Ch], dword ptr [eax+10h], dword ptr [eax+14h], dword ptr [eax+18h], \
		dword ptr [eax+1Ch]
	add	esp, 28h
	ret
Pointer8ToAscii	endp

Dword1ToAscii	proc
	call	_wsprintfA, offset tempbuffer2, offset mask_wsprintf1, eax
	add	esp, 0Ch
	ret
Dword1ToAscii	endp

Dword4ToAscii	proc
	call	_wsprintfA, offset tempbuffer2, offset mask_wsprintf2, eax, ebx, ecx, edx
	add	esp, 18h
	ret
Dword4ToAscii	endp

Dword5ToAscii	proc
	call	_wsprintfA, offset tempbuffer2, offset mask_wsprintf3, eax, ebx, ecx, edx, esi
	add	esp, 1Ch
	ret
Dword5ToAscii	endp

HashBuffer	proc	buffer:dword,len:dword		;result: eax=number of byte written
		uses	esi				;	 ecx=address of buffer
	mov	ecx, crypt_current
	mov	eax, dword ptr [ecx+0Ch]
	mov	crypt_wsprintf, eax
	call	dword ptr [ecx+08h], buffer, len	;result in eax:ebx:ecx:edx
	call	dword ptr [crypt_wsprintf]
	mov	ecx, offset tempbuffer2
	ret
HashBuffer	endp

;*******************************************************************
