.486p					;486 instruction set enable
.model flat, stdCALL  

;extrn	ExitProcess : PROC
;extrn	RtlMoveMemory : PROC

Comment % RIPEMD-128 - My very little simple implemantation ;)
In the main procedure (RIPEMD128_Transform), there is no jmp/call !
Written by Lucifer48 [PC]

(see "ripemd160.ps" for more details)

4 functions:
* RIPEMD128_Init
* RIPEMD128_Pad
* RIPEMD128_Transform
* RIPEMD128_Compute	<- main function

History:
-------
v1.0	(August, 16th 2001) - first version

TODO:
----
* Modify the RIPEMD128_Pad function : I can save a RtlMoveMemory, and add ZeroMemory.. 
  (it's for the padding.. i know that i copy only 0s..)

Remark:
------
* Page 13 (of "ripemd160.ps"), there is an error :
  RIPEMD-128 (1 million times "a") = 96d032eea11d79c1c3ffbb2e7af8b4bf
  Both this source and their source ("hashtest.c") returns :
  4A7F5723F954EBA1216C9D8F6320431F

	%

;*******************************************************************
;*  DATA                                                           *
;*******************************************************************
	.data
padding3	db 80h, 63 dup(0)
nbloop3		dd 0			;number (-1 or -2) of loop (block of 512-bit processing).
					;the last 512-bit block is located at (offset lastblock)
	.data?	
lastblock3	db 64 dup(?)		;last 512-bit block after padding
		db 64 dup(?)		;if length (mod 64) > 55 then another 512-bit block is required
					;// example: length = 59 ; pad = 61 ; 64-bit length representation = 8
					;// which makes two blocks: 59+5 AND 56+8
lastblock3_use	dd ?			;use the second lastblock ?

a_ripemd128	dd ?	;state
b_ripemd128	dd ?
c_ripemd128	dd ?
d_ripemd128	dd ?

save1_a_ripemd128	dd ?
save1_b_ripemd128	dd ?
save1_c_ripemd128	dd ?
save1_d_ripemd128	dd ?
save2_a_ripemd128	dd ?
save2_b_ripemd128	dd ?
save2_c_ripemd128	dd ?
save2_d_ripemd128	dd ?

length_ripemd128	dq ?		;64-bit representation of the messages length (before padding bits were added)

;*******************************************************************
;*  CODE                                                           *
;*******************************************************************
	.code

;*******************************************************************
;* Twelve important macros					   *
;*******************************************************************
F	MACRO 					;F(X,Y,Z) = X xor Y xor Z
	xor	eax, ecx			;eax = X
	xor	eax, edx			;ecx = Y
	ENDM					;edx = Z

FF	MACRO	_a, _b, _c, _d, x, s		;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F
	add	eax, _a
	add	eax, x
	rol	eax, s	
	mov	_a, eax
	ENDM

G	MACRO					;G(X,Y,Z) = XY v not(X) Z
	and	ecx, eax			;eax = X
	not	eax				;ecx = Y
	and	eax, edx			;edx = Z
	or	eax, ecx	
	ENDM

GG	MACRO	_a, _b, _c, _d, x, s		;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	G
	add	eax, _a
	add	eax, x
	add	eax, 5a827999h
	rol	eax, s
	mov	_a, eax
	ENDM

H	MACRO					;H(X,Y,Z) = (X v not(Y)) xor Z )
	not	ecx				;eax = X
	or	eax, ecx			;ecx = Y
	xor	eax, edx			;edx = Z
	ENDM

HH	MACRO	_a, _b, _c, _d, x, s		;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	H
	add	eax, _a
	add	eax, x
	add	eax, 6ed9eba1h
	rol	eax, s
	mov	_a, eax
	ENDM

I	MACRO					;I(X,Y,Z) = XZ v Y not(Z)
	and	eax, edx			;eax = X
	not	edx				;ecx = Y
	and	ecx, edx			;edx = Z
	or	eax, ecx
	ENDM

II	MACRO	_a, _b, _c, _d, x, s		;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	I
	add	eax, _a
	add	eax, x
	add	eax, 8f1bbcdch
	rol	eax, s
	mov	_a, eax
	ENDM

III	MACRO	_a, _b, _c, _d, x, s		;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	I
	add	eax, _a
	add	eax, x
	add	eax, 50a28be6h
	rol	eax, s
	mov	_a, eax
	ENDM

HHH	MACRO	_a, _b, _c, _d, x, s		;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	H
	add	eax, _a
	add	eax, x
	add	eax, 5c4dd124h
	rol	eax, s
	mov	_a, eax
	ENDM

GGG	MACRO	_a, _b, _c, _d, x, s		;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	G
	add	eax, _a
	add	eax, x
	add	eax, 6d703ef3h
	rol	eax, s
	mov	_a, eax
	ENDM

FFF	MACRO	_a, _b, _c, _d, x, s		;all args are dwords (same as FF)
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F
	add	eax, _a
	add	eax, x
	rol	eax, s	
	mov	_a, eax
	ENDM

;*******************************************************************
;* RIPEMD128_Init                                                 *
;*******************************************************************
RIPEMD128_Init	proc
	mov	dword ptr [a_ripemd128], 067452301h	; 
	mov	dword ptr [b_ripemd128], 0EFCDAB89h	;chaining
	mov	dword ptr [c_ripemd128], 098BADCFEh	;variables
	mov	dword ptr [d_ripemd128], 010325476h	;
	ret
RIPEMD128_Init	endp

;*******************************************************************
;* RIPEMD128_Pad - Pad out to 56 mod 64                            *
;* - buffer: data buffer					   *
;* - len : length (in bytes of the buffer)			   *
;*******************************************************************
RIPEMD128_Pad	proc	buffer:dword, len:dword
		local	lenmod: dword
		local	endlen: dword
	mov	ecx, len
	mov	eax, ecx
	shr	eax, 6		;64 bytes = one 512-bit block
	mov	nbloop3, eax	;(located at offset buffer)
	mov	eax, 56d
	and	ecx, 3Fh
	.if	(ecx<56d)
	 mov	lastblock3_use,1 ;1 * 512-bit block is needed (offset lastblock)
	 mov	endlen, 56d	;store length at "dword ptr [lastblock+56d]" and "dword ptr [lastblock+60d]"
	.else
	 mov	lastblock3_use,2	;2 * 512-bit block is needed (offset lastblock)
	 add	eax, 64d
	 mov	endlen, 120d	;store length at "dword ptr [lastblock+120d]" and "dword ptr [lastblock+124d]"
	.endif	
	sub	eax, ecx	;number of byte of padding (0x80 ..)	 
	mov	lenmod, ecx	;len mod 64

	;we are now making the lastbock (offset lastblock3)
	mov	esi, buffer
	mov	edi, offset lastblock3
	mov	ecx, nbloop3
	add	ecx ,ecx
	mov	edx, ecx
	add	edx, edx
	lea	ecx, [2*ecx+edx]
	lea	esi, [8*ecx+esi]	;esi = buffer + 64*nbloop

	push	eax			;number of byte of padding (0x80 ..)
	call	RtlMoveMemory, edi, esi, lenmod
	add	edi, lenmod
	call	RtlMoveMemory, edi, offset padding3	;last arg is already on the stack	
	;
	mov	ecx, len		;64-bit representation of "len"
	mov	edx, ecx
	and	edx, 0E0000000h		;save the 3 highest bits
	bswap	edx
	shl	ecx, 3			;len is in bytes, it's now in bits
	mov	dword ptr [length_ripemd128], ecx
	mov	dword ptr [length_ripemd128+4], edx
	;
	mov	edx, endlen
	mov	eax, dword ptr [length_ripemd128+0]
	mov	ecx, dword ptr [length_ripemd128+4]
	mov	dword ptr [lastblock3+edx], eax
	mov	dword ptr [lastblock3+edx+4], ecx
	ret
RIPEMD128_Pad	endp

;*******************************************************************
;* RIPEMD128_Transform - the main algo (uses eax, ecx, edx)        *
;*  - in edi : 512-bit block					   *
;*******************************************************************
RIPEMD128_Transform	proc
	mov	eax, dword ptr [a_ripemd128]
	mov	dword ptr [save1_a_ripemd128], eax
	mov	dword ptr [save2_a_ripemd128], eax
	mov	ecx, dword ptr [b_ripemd128]
	mov	dword ptr [save1_b_ripemd128], ecx
	mov	dword ptr [save2_b_ripemd128], ecx
	mov	eax, dword ptr [c_ripemd128]
	mov	dword ptr [save1_c_ripemd128], eax
	mov	dword ptr [save2_c_ripemd128], eax
	mov	ecx, dword ptr [d_ripemd128]
	mov	dword ptr [save1_d_ripemd128], ecx
	mov	dword ptr [save2_d_ripemd128], ecx

;/* round 1 */
	FF save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*00], 11
	FF save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*01], 14
	FF save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*02], 15
	FF save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*03], 12
	FF save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*04], 5
	FF save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*05], 8
	FF save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*06], 7
	FF save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*07], 9
	FF save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*08], 11
	FF save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*09], 13
	FF save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*10], 14
	FF save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*11], 15
	FF save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*12], 6
	FF save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*13], 7
	FF save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*14], 9
	FF save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*15], 8
;/* round 2 */
	GG save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*07], 7
	GG save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*04], 6
	GG save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*13], 8
	GG save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*01], 13
	GG save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*10], 11
	GG save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*06], 9
	GG save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*15], 7
	GG save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*03], 15
	GG save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*12], 7
	GG save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*00], 12
	GG save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*09], 15
	GG save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*05], 9
	GG save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*02], 11
	GG save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*14], 7
	GG save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*11], 13
	GG save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*08], 12
;/* round 3 */
	HH save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*03], 11
	HH save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*10], 13
	HH save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*14], 6
	HH save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*04], 7
	HH save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*09], 14
	HH save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*15], 9
	HH save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*08], 13
	HH save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*01], 15
	HH save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*02], 14
	HH save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*07], 8
	HH save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*00], 13
	HH save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*06], 6
	HH save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*13], 5
	HH save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*11], 12
	HH save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*05], 7
	HH save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*12], 5
;/* round 4 */
	II save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*01], 11
	II save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*09], 12
	II save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*11], 14
	II save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*10], 15
	II save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*00], 14
	II save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*08], 15
	II save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*12], 9
	II save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*04], 8
	II save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*13], 9
	II save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*03], 14
	II save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*07], 5
	II save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*15], 6
	II save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, edi[4*14], 8
	II save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, save1_c_ripemd128, edi[4*05], 6
	II save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, save1_b_ripemd128, edi[4*06], 5
	II save1_b_ripemd128, save1_c_ripemd128, save1_d_ripemd128, save1_a_ripemd128, edi[4*02], 12
;/* parallel round 1 */
	III save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*05], 8
	III save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*14], 9
	III save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*07], 9
	III save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*00], 11
	III save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*09], 13
	III save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*02], 15
	III save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*11], 15
	III save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*04], 5
	III save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*13], 7
	III save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*06], 7
	III save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*15], 8
	III save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*08], 11
	III save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*01], 14
	III save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*10], 14
	III save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*03], 12
	III save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*12], 6
;/* parallel round 2 */
	HHH save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*06], 9
	HHH save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*11], 13
	HHH save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*03], 15
	HHH save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*07], 7
	HHH save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*00], 12
	HHH save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*13], 8
	HHH save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*05], 9
	HHH save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*10], 11
	HHH save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*14], 7
	HHH save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*15], 7
	HHH save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*08], 12
	HHH save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*12], 7
	HHH save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*04], 6
	HHH save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*09], 15
	HHH save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*01], 13
	HHH save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*02], 11
;/* parallel round 3 */   
	GGG save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*15], 9
	GGG save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*05], 7
	GGG save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*01], 15
	GGG save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*03], 11
	GGG save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*07], 8
	GGG save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*14], 6
	GGG save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*06], 6
	GGG save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*09], 14
	GGG save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*11], 12
	GGG save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*08], 13
	GGG save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*12], 5
	GGG save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*02], 14
	GGG save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*10], 13
	GGG save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*00], 13
	GGG save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*04], 7
	GGG save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*13], 5
;/* parallel round 4 */
	FFF save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*08], 15
	FFF save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*06], 5
	FFF save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*04], 8
	FFF save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*01], 11
	FFF save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*03], 14
	FFF save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*11], 14
	FFF save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*15], 6
	FFF save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*00], 14
	FFF save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*05], 6
	FFF save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*12], 9
	FFF save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*02], 12
	FFF save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*13], 9
	FFF save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, edi[4*09], 12
	FFF save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, save2_c_ripemd128, edi[4*07], 5
	FFF save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, save2_b_ripemd128, edi[4*10], 15
	FFF save2_b_ripemd128, save2_c_ripemd128, save2_d_ripemd128, save2_a_ripemd128, edi[4*14], 8
;/* combine results */
	mov	ecx, b_ripemd128
	add	ecx, save1_c_ripemd128
	add	ecx, save2_d_ripemd128
	;
	mov	eax, c_ripemd128
	add	eax, save1_d_ripemd128
	add	eax, save2_a_ripemd128
	mov	b_ripemd128, eax
	;
	mov	eax, d_ripemd128
	add	eax, save1_a_ripemd128
	add	eax, save2_b_ripemd128
	mov	c_ripemd128, eax
	;
	mov	eax, a_ripemd128
	add	eax, save1_b_ripemd128
	add	eax, save2_c_ripemd128
	mov	d_ripemd128, eax
	;
	mov	a_ripemd128, ecx
	ret
RIPEMD128_Transform	endp

;*******************************************************************
;* RIPEMD128_Compute - result: eax:ebx:ecx:edx		  	   *
;*******************************************************************
RIPEMD128_Compute	proc	buffer:dword, len:dword
	call	RIPEMD128_Init
	call	RIPEMD128_Pad, buffer, len
	mov	edi, buffer
	mov	esi, nbloop3
ripemd128_loop:
	test	esi, esi
	jz	ripemd128_loop_end
	call	RIPEMD128_Transform
	add	edi, 64d
	dec	esi
	jmp	ripemd128_loop
ripemd128_loop_end:

	mov	edi, offset lastblock3
	mov	esi, lastblock3_use
ripemd128_loop2:
	test	esi, esi
	jz	ripemd128_loop_end2
	call	RIPEMD128_Transform		;don't use esi
	add	edi, 64d
	dec	esi
	jmp	ripemd128_loop2
ripemd128_loop_end2:

	mov	eax, a_ripemd128
	mov	ebx, b_ripemd128
	mov	ecx, c_ripemd128
	mov	edx, d_ripemd128

	bswap	eax
	bswap	ebx
	bswap	ecx
	bswap	edx
	ret
RIPEMD128_Compute	endp

;*******************************************************************
;* RIPEMD128_Test -					  	   *
;*******************************************************************
;test0	db 0
;test0size = 0		;RIPEMD-128 ("") = CDF26213 A150DC3E CB610F18 F6B38B46
;test1	db "a"
;test1size = 1		;RIPEMD-128 ("a") = 86BE7AFA 339D0FC7 CFC785E7 2F578D33
;test2	db 8 dup("1234567890")
;test2size = 80		;RIPEMD-128 = 3F45EF19 4732C2DB B2C4A2C7 69795FA3
;test3	db "message digest"
;test3size = 14		;RIPEMD-128 = 9E327B3D 6E523062 AFC1132D 7DF8D1B8
;test4	db  1000000d dup("a")
;test4size = 1000000d	;RIPEMD-128 = 
;
;main:					;the code begins here !
;	call	RIPEMD128_Compute, offset test4, test4size
;	call	ExitProcess, 0		;End (exit) program
;	end main			;end of code
