.486p					;486 instruction set enable
.model flat, stdCALL  

;extrn	ExitProcess : PROC
;extrn	RtlMoveMemory : PROC

Comment % RIPEMD-160 - My very little simple implemantation ;)
In the main procedure (RIPEMD160_Transform), there is no jmp/call !
Written by Lucifer48 [PC]

(see "ripemd160.ps" for more details)

4 functions:
* RIPEMD160_Init
* RIPEMD160_Pad
* RIPEMD160_Transform
* RIPEMD160_Compute	<- main function

History:
-------
v1.0	(August, 16th 2001) - first version

TODO:
----
* Modify the RIPEMD160_Pad function : I can save a RtlMoveMemory, and add ZeroMemory.. 
  (it's for the padding.. i know that i copy only 0s..)

Remark:
------
* Page 13 (of "ripemd160.ps"), there is an error :
  RIPEMD-160 (1 million times "a") = 052B820A1724CA20AFBDBE37DE25BA78207564D0
  Both this source and their source ("hashtest.c") returns : 52783243c1697bdbe16d37f97f68f08325dc1528
  Am I wrong or 1 million = 1000000 ?
	%

;*******************************************************************
;*  DATA                                                           *
;*******************************************************************
	.data
padding4	db	80h, 63 dup(0)
					;the last 512-bit block is located at (offset lastblock)
	.data?	
lastblock4	db 64 dup(?)		;last 512-bit block after padding
		db 64 dup(?)		;if length (mod 64) > 55 then another 512-bit block is required
					;// example: length = 59 ; pad = 61 ; 64-bit length representation = 8
					;// which makes two blocks: 59+5 AND 56+8
lastblock4_use	dd ?			;use the second lastblock ?

a_ripemd160	dd ?	;state
b_ripemd160	dd ?
c_ripemd160	dd ?
d_ripemd160	dd ?
e_ripemd160	dd ?

save1_a_ripemd160	dd ?
save1_b_ripemd160	dd ?
save1_c_ripemd160	dd ?
save1_d_ripemd160	dd ?
save1_e_ripemd160	dd ?
save2_a_ripemd160	dd ?
save2_b_ripemd160	dd ?
save2_c_ripemd160	dd ?
save2_d_ripemd160	dd ?
save2_e_ripemd160	dd ?

length_ripemd160	dq ?		;64-bit representation of the messages length (before padding bits were added)
nbloop_ripemd160	dd ?		;number (-1 or -2) of loop (block of 512-bit processing).

;*******************************************************************
;*  CODE                                                           *
;*******************************************************************
	.code

;*******************************************************************
;* Fifteen important macros					   *
;*******************************************************************
F	MACRO 					;F(X,Y,Z) = X xor Y xor Z
	xor	eax, ecx			;eax = X
	xor	eax, edx			;ecx = Y
	ENDM					;edx = Z

FF	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F
	add	eax, _a
	add	eax, x
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	rol	ecx, 10
	mov	_c, ecx
	ENDM

G	MACRO					;G(X,Y,Z) = XY v not(X) Z
	and	ecx, eax			;eax = X
	not	eax				;ecx = Y
	and	eax, edx			;edx = Z
	or	eax, ecx	
	ENDM

GG	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	G
	add	eax, _a
	add	eax, x
	add	eax, 5a827999h
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	mov	ecx, _c
	rol	ecx, 10
	mov	_c, ecx
	ENDM

H	MACRO					;H(X,Y,Z) = (X v not(Y)) xor Z )
	not	ecx				;eax = X
	or	eax, ecx			;ecx = Y
	xor	eax, edx			;edx = Z
	ENDM

HH	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	H
	add	eax, _a
	add	eax, x
	add	eax, 6ed9eba1h
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	mov	ecx, _c
	rol	ecx, 10
	mov	_c, ecx
	ENDM

I	MACRO					;I(X,Y,Z) = XZ v Y not(Z)
	and	eax, edx			;eax = X
	not	edx				;ecx = Y
	and	edx, ecx			;edx = Z
	or	eax, edx
	ENDM

II	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	I
	add	eax, _a
	add	eax, x
	add	eax, 8f1bbcdch
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	rol	ecx, 10
	mov	_c, ecx
	ENDM

J	MACRO					;J(X,Y,Z) = X xor ( Y v not(Z) )
	not	edx				;eax = X
	or	edx, ecx			;ecx = Y
	xor	eax, edx			;edx = Z
	ENDM

JJ	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	J
	add	eax, _a
	add	eax, x
	add	eax, 0a953fd4eh
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	rol	ecx, 10
	mov	_c, ecx
	ENDM

JJJ	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	J
	add	eax, _a
	add	eax, x
	add	eax, 50a28be6h
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	rol	ecx, 10
	mov	_c, ecx
	ENDM

III	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	I
	add	eax, _a
	add	eax, x
	add	eax, 5c4dd124h
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	rol	ecx, 10
	mov	_c, ecx
	ENDM

HHH	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	H
	add	eax, _a
	add	eax, x
	add	eax, 6d703ef3h
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	mov	ecx, _c
	rol	ecx, 10
	mov	_c, ecx
	ENDM

GGG	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	G
	add	eax, _a
	add	eax, x
	add	eax, 7a6d76e9h
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	mov	ecx, _c
	rol	ecx, 10
	mov	_c, ecx
	ENDM

FFF	MACRO	_a, _b, _c, _d, _e, x, s	;all args are dwords (same as FF)
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F
	add	eax, _a
	add	eax, x
	rol	eax, s
	add	eax, _e
	mov	_a, eax
	rol	ecx, 10
	mov	_c, ecx
	ENDM

;*******************************************************************
;* RIPEMD160_Init                                                 *
;*******************************************************************
RIPEMD160_Init	proc
	mov	dword ptr [a_ripemd160], 067452301h	; 
	mov	dword ptr [b_ripemd160], 0EFCDAB89h	;chaining
	mov	dword ptr [c_ripemd160], 098BADCFEh	;variables
	mov	dword ptr [d_ripemd160], 010325476h	;
	mov	dword ptr [e_ripemd160], 0c3d2e1f0h	;
	ret
RIPEMD160_Init	endp

;*******************************************************************
;* RIPEMD160_Pad - Pad out to 56 mod 64                            *
;* - buffer: data buffer					   *
;* - len : length (in bytes of the buffer)			   *
;*******************************************************************
RIPEMD160_Pad	proc	buffer:dword, len:dword
		local	lenmod: dword
		local	endlen: dword
	mov	ecx, len
	mov	eax, ecx
	shr	eax, 6			;64 bytes = one 512-bit block
	mov	nbloop_ripemd160, eax	;(located at offset buffer)
	mov	eax, 56d
	and	ecx, 3Fh
	.if	(ecx<56d)
	 mov	lastblock4_use,1 ;1 * 512-bit block is needed (offset lastblock)
	 mov	endlen, 56d	;store length at "dword ptr [lastblock+56d]" and "dword ptr [lastblock+60d]"
	.else
	 mov	lastblock4_use,2	;2 * 512-bit block is needed (offset lastblock)
	 add	eax, 64d
	 mov	endlen, 120d	;store length at "dword ptr [lastblock+120d]" and "dword ptr [lastblock+124d]"
	.endif	
	sub	eax, ecx	;number of byte of padding (0x80 ..)	 
	mov	lenmod, ecx	;len mod 64

	;we are now making the lastbock (offset lastblock4)
	mov	esi, buffer
	mov	edi, offset lastblock4
	mov	ecx, nbloop_ripemd160
	add	ecx ,ecx
	mov	edx, ecx
	add	edx, edx
	lea	ecx, [2*ecx+edx]
	lea	esi, [8*ecx+esi]	;esi = buffer + 64*nbloop

	push	eax			;number of byte of padding (0x80 ..)
	call	RtlMoveMemory, edi, esi, lenmod
	add	edi, lenmod
	call	RtlMoveMemory, edi, offset padding4	;last arg is already on the stack	
	;
	mov	ecx, len		;64-bit representation of "len"
	mov	edx, ecx
	and	edx, 0E0000000h		;save the 3 highest bits
	bswap	edx
	shl	ecx, 3			;len is in bytes, it's now in bits
	mov	dword ptr [length_ripemd160], ecx
	mov	dword ptr [length_ripemd160+4], edx
	;
	mov	edx, endlen
	mov	eax, dword ptr [length_ripemd160+0]
	mov	ecx, dword ptr [length_ripemd160+4]
	mov	dword ptr [lastblock4+edx], eax
	mov	dword ptr [lastblock4+edx+4], ecx
	ret
RIPEMD160_Pad	endp

;*******************************************************************
;* RIPEMD160_Transform - the main algo (uses eax, ecx, edx)        *
;*  - in edi : 512-bit block					   *
;*******************************************************************
RIPEMD160_Transform	proc
	mov	eax, dword ptr [a_ripemd160]
	mov	dword ptr [save1_a_ripemd160], eax
	mov	dword ptr [save2_a_ripemd160], eax
	mov	ecx, dword ptr [b_ripemd160]
	mov	dword ptr [save1_b_ripemd160], ecx
	mov	dword ptr [save2_b_ripemd160], ecx
	mov	eax, dword ptr [c_ripemd160]
	mov	dword ptr [save1_c_ripemd160], eax
	mov	dword ptr [save2_c_ripemd160], eax
	mov	ecx, dword ptr [d_ripemd160]
	mov	dword ptr [save1_d_ripemd160], ecx
	mov	dword ptr [save2_d_ripemd160], ecx
	mov	eax, dword ptr [e_ripemd160]
	mov	dword ptr [save1_e_ripemd160], eax
	mov	dword ptr [save2_e_ripemd160], eax

;/* round 1 */
	FF save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*00], 11
	FF save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*01], 14
	FF save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*02], 15
	FF save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*03], 12
	FF save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*04], 5
	FF save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*05], 8
	FF save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*06], 7
	FF save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*07], 9
	FF save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*08], 11
	FF save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*09], 13
	FF save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*10], 14
	FF save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*11], 15
	FF save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*12], 6
	FF save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*13], 7
	FF save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*14], 9
	FF save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*15], 8
;/* round 2 */
	GG save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*07], 7
	GG save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*04], 6
	GG save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*13], 8
	GG save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*01], 13
	GG save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*10], 11
	GG save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*06], 9
	GG save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*15], 7
	GG save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*03], 15
	GG save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*12], 7
	GG save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*00], 12
	GG save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*09], 15
	GG save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*05], 9
	GG save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*02], 11
	GG save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*14], 7
	GG save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*11], 13
	GG save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*08], 12
;/* round 3 */
	HH save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*03], 11
	HH save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*10], 13
	HH save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*14], 6
	HH save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*04], 7
	HH save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*09], 14
	HH save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*15], 9
	HH save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*08], 13
	HH save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*01], 15
	HH save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*02], 14
	HH save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*07], 8
	HH save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*00], 13
	HH save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*06], 6
	HH save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*13], 5
	HH save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*11], 12
	HH save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*05], 7
	HH save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*12], 5
;/* round 4 */
	II save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*01], 11
	II save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*09], 12
	II save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*11], 14
	II save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*10], 15
	II save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*00], 14
	II save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*08], 15
	II save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*12], 9
	II save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*04], 8
	II save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*13], 9
	II save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*03], 14
	II save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*07], 5
	II save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*15], 6
	II save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*14], 8
	II save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*05], 6
	II save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*06], 5
	II save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*02], 12
;/* round 5 */
	JJ save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*04], 9
	JJ save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*00], 15
	JJ save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*05], 5
	JJ save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*09], 11
	JJ save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*07], 6
	JJ save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*12], 8
	JJ save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*02], 13
	JJ save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*10], 12
	JJ save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*14], 5
	JJ save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*01], 12
	JJ save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*03], 13
	JJ save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, edi[4*08], 14
	JJ save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, edi[4*11], 11
	JJ save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, save1_c_ripemd160, edi[4*06], 8
	JJ save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, save1_b_ripemd160, edi[4*15], 5
	JJ save1_b_ripemd160, save1_c_ripemd160, save1_d_ripemd160, save1_e_ripemd160, save1_a_ripemd160, edi[4*13], 6
;/* parallel round 1 */
	JJJ save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*05], 8
	JJJ save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*14], 9
	JJJ save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*07], 9
	JJJ save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*00], 11
	JJJ save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*09], 13
	JJJ save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*02], 15
	JJJ save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*11], 15
	JJJ save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*04], 5
	JJJ save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*13], 7
	JJJ save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*06], 7
	JJJ save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*15], 8
	JJJ save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*08], 11
	JJJ save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*01], 14
	JJJ save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*10], 14
	JJJ save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*03], 12
	JJJ save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*12], 6
;/* parallel round 2 */
	III save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*06], 9 
	III save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*11], 13
	III save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*03], 15
	III save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*07], 7
	III save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*00], 12
	III save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*13], 8
	III save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*05], 9
	III save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*10], 11
	III save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*14], 7
	III save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*15], 7
	III save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*08], 12
	III save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*12], 7
	III save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*04], 6
	III save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*09], 15
	III save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*01], 13
	III save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*02], 11
;/* parallel round 3 */
	HHH save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*15], 9
	HHH save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*05], 7
	HHH save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*01], 15
	HHH save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*03], 11
	HHH save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*07], 8
	HHH save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*14], 6
	HHH save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*06], 6
	HHH save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*09], 14
	HHH save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*11], 12
	HHH save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*08], 13
	HHH save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*12], 5
	HHH save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*02], 14
	HHH save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*10], 13
	HHH save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*00], 13
	HHH save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*04], 7
	HHH save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*13], 5
;/* parallel round 4 */   
	GGG save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*08], 15
	GGG save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*06], 5
	GGG save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*04], 8
	GGG save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*01], 11
	GGG save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*03], 14
	GGG save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*11], 14
	GGG save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*15], 6
	GGG save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*00], 14
	GGG save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*05], 6
	GGG save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*12], 9
	GGG save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*02], 12
	GGG save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*13], 9
	GGG save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*09], 12
	GGG save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*07], 5
	GGG save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*10], 15
	GGG save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*14], 8
;/* parallel round 5 */
	FFF save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*12] , 8
	FFF save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*15] , 5
	FFF save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*10] , 12
	FFF save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*04] , 9
	FFF save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*01] , 12
	FFF save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*05] , 5
	FFF save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*08] , 14
	FFF save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*07] , 6
	FFF save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*06] , 8
	FFF save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*02] , 13
	FFF save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*13] , 6
	FFF save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, edi[4*14] , 5
	FFF save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, edi[4*00] , 15
	FFF save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, save2_c_ripemd160, edi[4*03] , 13
	FFF save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, save2_b_ripemd160, edi[4*09] , 11
	FFF save2_b_ripemd160, save2_c_ripemd160, save2_d_ripemd160, save2_e_ripemd160, save2_a_ripemd160, edi[4*11] , 11

;/* combine results */
	mov	ecx, b_ripemd160
	add	ecx, save1_c_ripemd160
	add	ecx, save2_d_ripemd160
	;
	mov	eax, c_ripemd160
	add	eax, save1_d_ripemd160
	add	eax, save2_e_ripemd160
	mov	b_ripemd160, eax
	;
	mov	eax, d_ripemd160
	add	eax, save1_e_ripemd160
	add	eax, save2_a_ripemd160
	mov	c_ripemd160, eax
	;
	mov	eax, e_ripemd160
	add	eax, save1_a_ripemd160
	add	eax, save2_b_ripemd160
	mov	d_ripemd160, eax
	;
	mov	eax, a_ripemd160
	add	eax, save1_b_ripemd160
	add	eax, save2_c_ripemd160
	mov	e_ripemd160, eax
	;
	mov	a_ripemd160, ecx
	ret
RIPEMD160_Transform	endp

;*******************************************************************
;* RIPEMD160_Compute - result: eax:ebx:ecx:edx		  	   *
;*******************************************************************
RIPEMD160_Compute	proc	buffer:dword, len:dword
	call	RIPEMD160_Init
	call	RIPEMD160_Pad, buffer, len
	mov	edi, buffer
	mov	esi, nbloop_ripemd160
ripemd160_loop:
	test	esi, esi
	jz	ripemd160_loop_end
	call	RIPEMD160_Transform
	add	edi, 64d
	dec	esi
	jmp	ripemd160_loop
ripemd160_loop_end:

	mov	edi, offset lastblock4
	mov	esi, lastblock4_use
ripemd160_loop2:
	test	esi, esi
	jz	ripemd160_loop_end2
	call	RIPEMD160_Transform		;don't use esi
	add	edi, 64d
	dec	esi
	jmp	ripemd160_loop2
ripemd160_loop_end2:

	mov	eax, a_ripemd160
	mov	ebx, b_ripemd160
	mov	ecx, c_ripemd160
	mov	edx, d_ripemd160
	mov	esi, e_ripemd160

	bswap	eax
	bswap	ebx
	bswap	ecx
	bswap	edx
	bswap	esi
	ret
RIPEMD160_Compute	endp

;*******************************************************************
;* RIPEMD160_Test -					  	   *
;*******************************************************************
;test0	db 0
;test0size = 0		;RIPEMD-160 ("") = 9C1185A5 C5E9FC54 61280897 7EE8F548 B2258D31
;test1	db "a"
;test1size = 1		;RIPEMD-160 ("a") = 0BDC9D2D 256B3EE9 DAAE347B E6F4DC83 5A467FFE
;test2	db 8 dup("1234567890")
;test2size = 80		;RIPEMD-160 = 9B752E45 573D4B39 F4DBD332 3CAB82BF 63326BFB
;test3	db "message digest"
;test3size = 14		;RIPEMD-160 = 5D0689EF 49D2FAE5 72B881B1 23A85FFA 21595F36
;test4	db  1000000d dup("a")
;test4size = 1000000d	;RIPEMD-160 = 
;
;main:					;the code begins here !
;	call	RIPEMD160_Compute, offset test4, test4size
;	call	ExitProcess, 0		;End (exit) program
;	end main			;end of code
