.486p					;486 instruction set enable
.model flat, stdCALL  

;extrn	ExitProcess : PROC
;extrn	RtlMoveMemory : PROC

Comment % SHA-1 - My very little simple implemantation ;)
In the main procedure (SHA_Transform), there is no call !
Written by Lucifer48 [PC]

History:
-------
v1.0	(August, 15th 2001) - first version

(see the "fip180-1.html" for more details)

4 functions:
* SHA_Init
* SHA_Pad
* SHA_Transform
* SHA_Compute	<- main function

	%

;*******************************************************************
;*  DATA                                                           *
;*******************************************************************
	.data
padding2	db	80h, 63 dup(0)
nbloop2		dd	0		;number (-1 or -2) of loop (block of 512-bit processing) [located at the user defined buffer]
					;the last 512-bit block is located at (offset lastblock)
	.data?	
w		dd 80 dup(?)
lastblock2	db 64 dup(?)		;last 512-bit block after padding
		db 64 dup(?)		;if length (mod 64) > 55 then another 512-bit block is required
					;// example: length = 59 ; pad = 61 ; 64-bit length representation = 8
					;// which makes two blocks: 59+5 AND 56+8
lastblock2_use	dd ?			;use the second lastblock ?

h0	dd ?	;state
h1	dd ?
h2	dd ?
h3	dd ?
h4	dd ?

save_h0	dd ?
save_h1	dd ?
save_h2	dd ?
save_h3	dd ?
save_h4	dd ?

sha_length	dq ?			;64-bit representation of the messages length (before padding bits were added)

;*******************************************************************
;*  CODE                                                           *
;*******************************************************************
	.code

;*******************************************************************
;* Eight important macros					   *
;*******************************************************************
F1	MACRO					;F1(B,C,D) = BC v not(B) D
	and	ecx, eax			;eax = B
	not	eax				;ecx = C
	and	eax, edx			;edx = D
	or	eax, ecx	
	ENDM					;result in eax [edx=_d]

ROUND1	MACRO	_a, _b, _c, _d, _e, wt, k
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F1					;eax = F1(B,C,D)
	add	eax, wt				;eax = F1(B,C,D) + wt
	add	eax, k				;eax = F1(B,C,D) + wt + k
	add	eax, _e				;eax = F1(B,C,D) + e + wt + k
	mov	_e, edx				;_e = _d
	mov	edx, _b
	mov	ecx, _a
	mov	_b, ecx				;_b = _a
	rol	ecx, 5
	add	eax, ecx			;eax = S5(A) + F1(B,C,D) + e + wt + k
	mov	ecx, _c
	mov	_d, ecx				;_d = _c
	ror	edx, 2
	mov	_c, edx				;_c = S30(B)
	mov	_a, eax				;_a = S5(A) + F1(B,C,D) + e + wt + k
	ENDM

F2	MACRO					;F2(B,C,D) = B xor C xor D
	xor	eax, ecx			;eax = B
	xor	eax, edx			;ecx = C
	ENDM					;edx = D

ROUND2	MACRO	_a, _b, _c, _d, _e, wt, k
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F2					;eax = F2(B,C,D)
	add	eax, wt				;eax = F2(B,C,D) + wt
	add	eax, k				;eax = F2(B,C,D) + wt + k
	add	eax, _e				;eax = F2(B,C,D) + e + wt + k
	mov	_e, edx				;_e = _d
	mov	_d, ecx				;_d = _c
	mov	ecx, _b
	ror	ecx, 2
	mov	_c, ecx				;_c = S30(B)
	mov	ecx, _a
	mov	_b, ecx				;_b = _a	
	rol	ecx, 5
	add	eax, ecx
	mov	_a, eax				;_a = S5(A) + F2(B,C,D) + e + wt + k	
	ENDM

F3	MACRO					;F3(B,C,D) = BC v BD v CD
	push	eax				;eax = B
	and	eax, ecx			;ecx = C
	and	ecx, edx			;edx = D
	or	eax, ecx
	pop	ecx
	and	ecx, edx
	or	eax, ecx
	ENDM					;result in eax [edx=_d]

ROUND3	MACRO	_a, _b, _c, _d, _e, wt, k
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F3					;eax = F3(B,C,D)
	add	eax, wt				;eax = F3(B,C,D) + wt
	add	eax, k				;eax = F3(B,C,D) + wt + k
	add	eax, _e				;eax = F3(B,C,D) + e + wt + k
	mov	_e, edx				;_e = _d
	mov	edx, _b
	mov	ecx, _a
	mov	_b, ecx				;_b = _a
	rol	ecx, 5
	add	eax, ecx			;eax = S5(A) + F3(B,C,D) + e + wt + k
	mov	ecx, _c
	mov	_d, ecx				;_d = _c
	ror	edx, 2
	mov	_c, edx				;_c = S30(B)
	mov	_a, eax				;_a = S5(A) + F3(B,C,D) + e + wt + k
	ENDM

F4	MACRO					;F4(B,C,D) = B xor C xor D	(= F2)
	xor	eax, ecx			;eax = B
	xor	eax, edx			;ecx = C
	ENDM					;edx = D

ROUND4	MACRO	_a, _b, _c, _d, _e, wt, k
	mov	eax, _b
	mov	ecx, _c
	mov	edx, _d
	F4					;eax = F4(B,C,D)
	add	eax, wt				;eax = F4(B,C,D) + wt
	add	eax, k				;eax = F4(B,C,D) + wt + k
	add	eax, _e				;eax = F4(B,C,D) + e + wt + k
	mov	_e, edx				;_e = _d
	mov	_d, ecx				;_d = _c
	mov	ecx, _b
	ror	ecx, 2
	mov	_c, ecx				;_c = S30(B)
	mov	ecx, _a
	mov	_b, ecx				;_b = _a	
	rol	ecx, 5
	add	eax, ecx
	mov	_a, eax				;_a = S5(A) + F4(B,C,D) + e + wt + k	
	ENDM

;*******************************************************************
;* SHA_Init                                                        *
;*******************************************************************
SHA_Init	proc
	mov	dword ptr [h0], 067452301h	; 
	mov	dword ptr [h1], 0EFCDAB89h	;chaining
	mov	dword ptr [h2], 098BADCFEh	;variables
	mov	dword ptr [h3], 010325476h	;
	mov	dword ptr [h4], 0C3D2E1F0h	;
	ret
SHA_Init	endp

;*******************************************************************
;* SHA_Pad - Pad out to 56 mod 64                                  *
;* - buffer: data buffer					   *
;* - len : length (in bytes of the buffer)			   *
;*******************************************************************
SHA_Pad	proc	buffer:dword, len:dword
		local	lenmod: dword
		local	endlen: dword
	mov	ecx, len
	mov	eax, ecx
	shr	eax, 6			;64 bytes = one 512-bit block
	mov	nbloop, eax		;(located at offset buffer)
	mov	eax, 56d
	and	ecx, 3Fh
	.if	(ecx<56d)
	 mov	lastblock2_use, 1	;1 * 512-bit block is needed (offset lastblock)
	 mov	endlen, 56d		;store length at "dword ptr [lastblock+56d]" and "dword ptr [lastblock+60d]"
	.else
	 mov	lastblock2_use, 2	;2 * 512-bit block is needed (offset lastblock)
	 add	eax, 64d
	 mov	endlen, 120d		;store length at "dword ptr [lastblock+120d]" and "dword ptr [lastblock+124d]"
	.endif	
	sub	eax, ecx		;number of byte of padding (0x80 ..)	 
	mov	lenmod, ecx		;len mod 64

	;we are now making the lastbock (offset lastblock)
	mov	esi, buffer
	mov	edi, offset lastblock2
	mov	ecx, nbloop
	add	ecx ,ecx
	mov	edx, ecx
	add	edx, edx
	lea	ecx, [2*ecx+edx]
	lea	esi, [8*ecx+esi]	;esi = buffer + 64*nbloop

	push	eax			;number of byte of padding (0x80 ..)
	call	RtlMoveMemory, edi, esi, lenmod
	add	edi, lenmod
	call	RtlMoveMemory, edi, offset padding2	;last arg is already on the stack	
	;
	mov	ecx, len		;64-bit representation of "len"
	mov	edx, ecx
	and	edx, 0E0000000h		;save the 3 highest bits
	bswap	edx
	shl	ecx, 3			;len is in bytes, it's now in bits
	mov	dword ptr [sha_length], ecx
	mov	dword ptr [sha_length+4], edx
	;
	mov	edx, endlen
	mov	eax, dword ptr [sha_length+4]		;
	mov	ecx, dword ptr [sha_length+0]		;difference:
	bswap	eax					;md5  : low-order word first
	bswap	ecx					;sha-1: hight-order word first
	mov	dword ptr [lastblock2+edx], eax		;
	mov	dword ptr [lastblock2+edx+4], ecx	;
	ret
SHA_Pad	endp

;*******************************************************************
;* SHA_Transform - the main algo (uses eax, ecx, edx)              *
;*  - in edi : 512-bit block					   *
;*******************************************************************
SHA_Transform	proc
	push	dword ptr [h0]
	pop	dword ptr [save_h0]
	push	dword ptr [h1]
	pop	dword ptr [save_h1]
	push	dword ptr [h2]
	pop	dword ptr [save_h2]
	push	dword ptr [h3]
	pop	dword ptr [save_h3]
	push	dword ptr [h4]
	pop	dword ptr [save_h4]

;/* Create the 80 32-bit words array (w) */
	FOR i, <0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15>
	 mov	eax, dword ptr [edi+4*i]
	 bswap	eax
	 mov	dword ptr [w+4*i], eax
	ENDM
	;hehe.. do you think i have written this manually !! You are dreaming : "Take[Range[79],-64]" (in Mathematica) will do the job for us.. ;)
	FOR i, <16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79>
	 mov	eax, dword ptr [w+(4*i)-12d]	;3*4
	 xor	eax, dword ptr [w+(4*i)-32d]	;8*4
	 xor	eax, dword ptr [w+(4*i)-56d]	;14*4
	 xor	eax, dword ptr [w+(4*i)-64d]	;16*4
	 rol	eax, 1
	 mov	dword ptr [w+i*4], eax
	ENDM

;/* 4 rounds */
	mov	esi, 5A827999h		;K0..K19
	FOR i, <0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19>
		ROUND1	h0,h1,h2,h3,h4, [w+4*i], esi
	ENDM
	mov	esi, 6ED9EBA1h		;K20..K39
	FOR i, <20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39>
		ROUND2	h0,h1,h2,h3,h4, [w+4*i], esi
	ENDM
	mov	esi, 8F1BBCDCh		;K40..K59
	FOR i, <40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59>
		ROUND3	h0,h1,h2,h3,h4, [w+4*i], esi
	ENDM
	mov	esi, 0CA62C1D6h		;K60..K79
	FOR i, <60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79>
		ROUND4	h0,h1,h2,h3,h4, [w+4*i], esi
	ENDM
;
	mov	eax, save_h0
	add	h0, eax
	mov	eax, save_h1
	add	h1, eax
	mov	eax, save_h2
	add	h2, eax
	mov	eax, save_h3
	add	h3, eax
	mov	eax, save_h4
	add	h4, eax
	ret
SHA_Transform	endp

;*******************************************************************
;* SHA_Compute - result: eax:ebx:ecx:edx		  	   *
;*******************************************************************
SHA_Compute	proc	buffer:dword, len:dword
		local	counter : dword
	call	SHA_Init
	call	SHA_Pad, buffer, len

	mov	edi, buffer
	mov	esi, nbloop
	mov	counter, esi
sha_loop:
	cmp	counter, 0
	jz	sha_loop_end
	call	SHA_Transform
	add	edi, 64d
	dec	counter
	jmp	sha_loop
sha_loop_end:

	mov	edi, offset lastblock2
	mov	esi, lastblock2_use
	mov	counter, esi
sha_loop2:
	cmp	counter, 0
	jz	sha_loop_end2
	call	SHA_Transform
	add	edi, 64d
	dec	counter
	jmp	sha_loop2
sha_loop_end2:

	mov	eax, h0
	mov	ebx, h1
	mov	ecx, h2
	mov	edx, h3
	mov	esi, h4
	ret
SHA_Compute	endp

;*******************************************************************
;* SHA_Test -						  	   *
;*******************************************************************
;test2	db "abc"
;test2size = 3		;SHA ("abc") = A9993E36 4706816A BA3E2571 7850C26C 9CD0D89D
;test3	db "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq"
;test3size = 56		;SHA = 84983E44 1C3BD26E BAAE4AA1 F95129E5 E54670F1
;test4	db 1000000d dup("a")
;test4size = 1000000d	;SHA = 34AA973C D4C4DAA4 F61EEB2B DBAD2731 6534016F
;
;main:					;the code begins here !
;	call	SHA_Compute, offset test4, test4size
;	call	ExitProcess, 0		;End (exit) program
;	end main			;end of code
