;********************************************************************
;* CheckMe v1.50 - Written by Lucifer48 [PC]   	            	    *
;********************************************************************
.486p                           	;486 instruction set enable
.model flat, stdCALL
include monwin32.inc                    ;mes constantes

CHECKME = 1
include ..\common\common.asm

;*******************************************************************
;*  RESOURCE EQUATES                                               *
;*******************************************************************
DIALOG_MAIN	equ 4848
MY_ICON		equ 4849

ID_DIRECTORY	equ 5000
ID_SELECTDIR	equ 5001
ID_PROGRESSION	equ 5002		;ListBox
ID_METHOD	equ 5003		;Combobox
ID_START	equ 5004

IDM_ABOUT	equ 6000
IDM_EXIT	equ 6001
IDM_OPT_ABSPATH	equ 6002		;Save full path info
IDM_OPT_RECDIR	equ 6003		;Recurse directory

;*******************************************************************
;*  DATA                                                           *
;*******************************************************************
         .data
         
lu48class_hInst	dd 0                    ;hInst

;/* About box stuff */
mamsgbox	MSGBOXPARAMS <Size MSGBOXPARAMS, ?, ?, offset about_text, offset about_title, MB_OK+MB_USERICON, MY_ICON, 0, 0, LANG_NEUTRAL>
about_text	db "Thanks for using this little proggy ;)",0Ah,0Dh, "(", ??date, ")",0
about_title	db "About...",0

;/* Errors */
error1		db "ERROR : Please select a target directory", 0
error2		db "ERROR : SHGetMalloc failed", 0
error3		db "ERROR : Can't create output file, aborted", 0

;/* Shell stuff */
getmyrep	BROWSEINFOA <?, NULL, offset tempbuffer, offset getmyrep_title, BIF_RETURNONLYFSDIRS or BIF_DONTGOBELOWDOMAIN, NULL, 0, 0>
getmyrep_title	db "Select a directory", 0
getmyrep_item	LPITEMIDLIST ?
malloc_inter	LPMALLOC ?	;it's my IMalloc object

;/*** Enumeration of files (from a given directory) - part 2/2 */
headerLOG	db "//",0Dh,0Ah
		db "// This file was created by checkme v1.50",0Dh,0Ah
		db "// (%02d/%02d/%04d %02d:%02d:%02d)",0Dh,0Ah
		db "//",0Dh,0Ah, 0

retourligne	db 0Dh,0Ah
slash		db "\", 0
find_filtre	db "\*", 0
header0		db "********** Computing...", 0
header1		db "adding...", 0
header2		db "skip directory...", 0
header3		db "fail...", 0
header4		db "********** Done :)", 0

;/* computation time */
header_time	db "********** Computation time : %d.%03d seconds", 0
clock		SYSTEMTIME ?	;used by the "makeheader" function only
tick1		dd ?		;gettickcount

;/*** options */
fullpath	dd 0			;Save full path info - 0=no ; 1=yes

	.data?
;/*** file mapping stuff */
fichier_mapp	dd ?
fichier_hwnd	dd ?
fichier_pointer dd ?
fichier_size	dd ?
lus		dd ?			;used by Writefile only

;/*** Enumeration of files (from a given directory) - part 2/2 */
DEEPER_DIRECTORY equ 10
findstruct	WIN32_FIND_DATA DEEPER_DIRECTORY dup(<?>)

;/*** path buffer */
tempbuffer	db DEEPER_DIRECTORY*(MAX_PATH+1) dup(?)	;always contains a directory path
tempbuffer2	db 2*MAX_PATH dup(?)

ThreadID	dd ?			;receives the thread identifier
save_hwnd	dd ?			;hwnd of windows (will be used by the thread)

;*******************************************************************
;*  CODE                                                           *
;*******************************************************************
         .code
main:                                   ;le code commence ici
	call	GetModuleHandle, NULL
	mov	[lu48class_hInst], eax
	
	call	DialogBoxParamA, lu48class_hInst, DIALOG_MAIN, 0, offset DialogWndProc, 0
	call	ExitProcess, NULL

;***********************************************************************
;* MAIN DIALOG                                                         *
;***********************************************************************
DialogWndProc	proc	hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD

	cmp	wmsg, WM_INITDIALOG
	jz	wminitdialog
	cmp	wmsg, WM_COMMAND
	jz	wmcommand
	cmp	wmsg,WM_CLOSE
	jz	wmclose
      	mov     eax, FALSE       
	ret
;--------------
wminitdialog:
	;call	GetCommandLineA		;finally i don't need it

	;get the current directory and display it
	call	GetCurrentDirectoryA, MAX_PATH-1, offset tempbuffer
	call	SendDlgItemMessage, hwnd, ID_DIRECTORY, WM_SETTEXT, 0, offset tempbuffer

	;fill the combobox..
	push	esi
	mov	esi, offset crypt_table
	xor	ecx, ecx
liste_crypt:
	mov	eax, dword ptr [esi+4]
	push	ecx
	call	SendDlgItemMessage, hwnd, ID_METHOD, CB_ADDSTRING, 0, eax
	pop	ecx
	add	esi, 10h
	inc	ecx
	cmp	ecx, crypt_number
	jnz	liste_crypt
	pop	esi
	call	SendDlgItemMessage, hwnd, ID_METHOD, CB_SETCURSEL, 0, 0

	;termine de remplir la structure MSGBOXPARAMS
	push	hwnd
	pop	[mamsgbox].msg_hwndOwner
	push	lu48class_hInst
	pop	[mamsgbox].msg_hInstance

        mov	eax, TRUE
        ret
;--------------
wmcommand:
	mov	eax,wparam
	cmp	ax, IDCANCEL
	jz	wmclose
	cmp	ax, IDM_EXIT
	jz	wmclose
	cmp	ax, IDM_ABOUT
	jz	aboutmsg
	cmp	ax, ID_START
	jz	startzetruc
	cmp	ax, ID_SELECTDIR
	jz	selectrep
	cmp	ax, IDM_OPT_ABSPATH
	jz	option_fullpath

	mov	eax, TRUE
	ret                     
	;--------------
	aboutmsg:
	call	MessageBoxIndirectA, offset mamsgbox
	mov	eax, TRUE
	ret 
	;--------------
	startzetruc:
	call	createcheckmefile, hwnd
	mov	eax, TRUE
	ret 
	;--------------
	selectrep:
	call	selectdir, hwnd
	mov	eax, TRUE
	ret 
	;--------------
	option_fullpath:
	call	GetMenu, hwnd
	.if (fullpath==0)
	 push	(MF_BYCOMMAND or MF_CHECKED)
	 mov	fullpath, 1
	.else
	 push	(MF_BYCOMMAND or MF_UNCHECKED)
	 mov	fullpath, 0
	.endif
	call	CheckMenuItem, eax, IDM_OPT_ABSPATH		;last parameter is already on the stack
	mov	eax, TRUE
	ret 
;--------------
wmclose:
	call	EndDialog, hwnd, NULL
        mov	eax, TRUE
        ret

DialogWndProc	endp

;*******************************************************************
;* Displays a dialog box that enables the user to select a shell   *
;* folder. [thanks to ShellCC.chm =) ]				   *
;*******************************************************************
selectdir	proc	h:dword
	call	CoInitialize, 0
	mov	eax, h
	mov	[getmyrep].bri_hwndOwner, eax
	call	SHBrowseForFolder, offset getmyrep
	test	eax, eax
	jz	findir			;cancel
	mov	getmyrep_item, eax			;windows allocated PIDL

	call	SHGetMalloc, offset malloc_inter	;Retrieves a pointer to the shell's IMalloc interface	
	cmp	eax, E_FAIL
	jz	findir

	call	SHGetPathFromIDList, getmyrep_item, offset tempbuffer
	callcom	IMallocVtbl_Free, malloc_inter, getmyrep_item
findir:
	call	SendDlgItemMessage, h, ID_DIRECTORY, WM_SETTEXT, 0, offset tempbuffer
	ret
erreur_malloc:
	call	SendDlgItemMessage, h, ID_PROGRESSION, LB_ADDSTRING, 0, offset error2
	ret
selectdir	endp

;*******************************************************************
;* createcheckmefile						   *
;*******************************************************************
createcheckmefile	proc	h:dword
	;clean the listbox
	call	SendDlgItemMessage, h, ID_PROGRESSION, LB_RESETCONTENT, 0, 0

	;first we must check the validity of ID_DIRECTORY
	call	SendDlgItemMessage, h, ID_DIRECTORY, WM_GETTEXT, MAX_PATH-1, offset tempbuffer
	cmp	byte ptr [tempbuffer], 0
	jz	notarget

	;obtain a handle to a directory  (it don't work under win98)
	;call	CreateFileA, offset tempbuffer, GENERIC_READ, FILE_SHARE_READ or FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, 0
	;call	GetLastError

	;eventually remove an ending '\'
	call	lstrlenA, offset tempbuffer
	cmp	byte ptr [tempbuffer+eax-1], '\'
	jnz	noantislash
	mov	byte ptr [tempbuffer+eax-1], 0
noantislash:
;***
; Ok, the ID_DIRECTORY is correct, let's go
;***
	;show the hourglass
        call	LoadCursor,NULL, IDC_WAIT
	call	SetCursor, eax

	;find the right encryption entry
	call	SendDlgItemMessage, h, ID_METHOD, CB_GETCURSEL, 0, 0
	shl	eax, 4
	add	eax, offset crypt_table
	mov	crypt_current, eax

	;create a thread (call	godirectory, 0)
	push	h
	pop	save_hwnd
	call	GetDlgItem, h, ID_START
	call	EnableWindow, eax, 0
	call	CreateThread, NULL, NULL, (offset godirectory), 0, NORMAL_PRIORITY_CLASS, offset ThreadID
	;call	CloseHandle, eax		;needed ???
       	call	GetDlgItem, h, ID_DIRECTORY	;focus on the ListBox
       	call	SetFocus, eax

	ret
notarget:
	call	SendDlgItemMessage, h, ID_PROGRESSION, LB_ADDSTRING, 0, offset error1
	ret
createcheckmefile	endp

;*******************************************************************
;* makeheader - fill the date+time in the header		   *
;*   - return in eax the number of bytes written		   *
;*******************************************************************
makeheader	proc
	call	GetLocalTime, offset clock
	xor	eax, eax
	xor	ecx, ecx
	mov	ax, [clock].wSecond
	mov	cx, [clock].wMinute
	push	eax
	push	ecx
	mov	ax, [clock].wHour
	mov	cx, [clock].wYear
	push	eax
	push	ecx
	mov	ax, [clock].wDay
	mov	cx, [clock].wMonth
	push	eax
	push	ecx
	call	_wsprintfA, offset tempbuffer2, offset headerLOG
	add	esp, 20h
	ret
makeheader	endp

;*******************************************************************
;* maketime - fill the comptation time				   *
;*******************************************************************
maketime	proc
	call	GetTickCount
	sub	eax, tick1
	xor	edx, edx
	mov	ecx, 1000d
	div	ecx
	call	_wsprintfA, offset tempbuffer2, offset header_time, eax, edx
	add	esp, 10h
	ret
maketime	endp

;*******************************************************************
;* godirectory							   *
;* (tempbuffer contain the "target" directory, ex: C:\XYZ)	   *
;*   - esi : contains the deep of the directory scan		   *
;*******************************************************************
godirectory	proc	level:dword	;level = param
		uses	ebx, edi, esi
		local 	fichier_log : dword	;used by CreateFileA
		local	findHandle : dword	;used by FindFirstFileA / FindNextFileA

	mov	esi, save_hwnd
	call	GetTickCount
	mov	tick1, eax

	;let's create the crc target file
	call	lstrcpy, offset tempbuffer2, offset tempbuffer
	call	lstrcat, offset tempbuffer2, offset slash
	mov	eax, crypt_current
	call	lstrcat, offset tempbuffer2, dword ptr [eax+0]
	call	CreateFileA, offset tempbuffer2, GENERIC_WRITE+GENERIC_READ, 0, 0, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
	cmp	eax, INVALID_HANDLE_VALUE	;-1
	jz	creationerror
	mov	fichier_log, eax
	
	call	makeheader
	call	WriteFile, fichier_log, offset tempbuffer2, eax, offset lus, 0

	;display and enumerate files
	call	SendDlgItemMessage, esi, ID_PROGRESSION, LB_ADDSTRING, 0, offset header0
	call	lstrcat, offset tempbuffer, offset find_filtre

	call	FindFirstFileA, offset tempbuffer, offset findstruct
	mov	findHandle, eax
	cmp	eax, INVALID_HANDLE_VALUE	;-1
	jz	rien_dans_rep
encore_dans_rep:
	mov	eax, offset findstruct.cFileName
	cmp	word ptr [eax], 002Eh		;"."
	jz	skip_dans_rep
	mov	ecx, dword ptr [eax]
	and	ecx, 00FFFFFFh
	cmp	ecx, 00002E2Eh			;".."
	jz	skip_dans_rep

	test	[findstruct].dwFileAttributes, FILE_ATTRIBUTE_DIRECTORY
	jz	agoodfile
; it's a directory
	push	eax
	call	lstrcpy, offset tempbuffer2, offset header2
	call	lstrcat, offset tempbuffer2					;eax is already on the stack
	call	SendDlgItemMessage, esi, ID_PROGRESSION, LB_ADDSTRING, NULL, offset tempbuffer2
	jmp	skip_dans_rep
agoodfile:
; it's a file - display it....
	push	eax								;filename (without path)
	push	eax
	call	lstrcpy, offset tempbuffer2, offset tempbuffer			;create the full name
	call	lstrlenA, offset tempbuffer2
	mov	byte ptr [tempbuffer2+eax-1], 0	
	call	lstrcat, offset tempbuffer2					;eax is already on the stack

	;map the file
	call	CreateFileA, offset tempbuffer2, GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	mov	fichier_hwnd, eax
	.if (eax==INVALID_HANDLE_VALUE)
	 push	offset header3
	.else
	;write file name in the log file
	  .if (fullpath==0)
	   mov	eax, [esp]
	  .else
	   mov	eax, offset tempbuffer2
	  .endif
	   push	eax
	   call	lstrlenA, eax
	   pop	ecx  
	   call	WriteFile, fichier_log, ecx, eax, offset lus, 0
	 call	WriteFile, fichier_log, offset retourligne, 2, offset lus, 0
	 
	 push	offset header1							;"adding..."
	 call	GetFileSize, fichier_hwnd, NULL
	 mov	fichier_size, eax
	 call	CreateFileMappingA, fichier_hwnd, NULL, PAGE_READONLY, NULL, NULL, NULL
	 mov	fichier_mapp, eax
	 call	MapViewOfFile, eax, FILE_MAP_READ, 0, 0, 0
	 mov	fichier_pointer, eax

	 call	HashBuffer, eax, fichier_size			;*** call the crc routine
								;*** results : ecx=adresse of computed data
								;***           eax=number of data written (in eax)
	 ;write crc result to the log file
	 call	WriteFile, fichier_log, ecx, eax, offset lus, 0
	 call	WriteFile, fichier_log, offset retourligne, 2, offset lus, 0

	 call	UnmapViewOfFile, fichier_pointer
	 call	CloseHandle, fichier_mapp
	 call	CloseHandle, fichier_hwnd
	.endif

	call	lstrcpy, offset tempbuffer2			;eax is already on the stack
	call	lstrcat, offset tempbuffer2			;eax is already on the stack
	call	SendDlgItemMessage, esi, ID_PROGRESSION, LB_ADDSTRING, NULL, offset tempbuffer2
;
skip_dans_rep:
	call	FindNextFileA, findHandle, offset findstruct
	test	eax, eax							;fin = 0
	jnz	encore_dans_rep
	call	FindClose, findHandle
rien_dans_rep:
;***
; End
;***
	call	CloseHandle, fichier_log
	call	SendDlgItemMessage, esi, ID_PROGRESSION, LB_ADDSTRING, 0, offset header4
	call	maketime
	call	SendDlgItemMessage, esi, ID_PROGRESSION, LB_ADDSTRING, 0, offset tempbuffer2
really_end:
       	call	GetDlgItem, esi, ID_START		;enable the start button
	call	EnableWindow, eax, 1
	ret
creationerror:
	call	SendDlgItemMessage, esi, ID_PROGRESSION, LB_ADDSTRING, 0, offset error3
	jmp	really_end
godirectory	endp

;*******************************************************************

; that's the end.. it's quite long for nothing.. with Perl the
; same program should be 15 lines long.. ;)

	end main			;end of code
