;********************************************************************
;* VerifyMe v1.15 - Written by Lucifer48 [PC]	    	       	    *
;********************************************************************

Comment %

History
-------
v1.00	* (08/01/01) - Initial version.
v1.01	* (08/09/01) - Added some code for md5 support
v1.02	* (08/15/01) - Added some code for sha-1 support
v1.03	* (08/16/01) - Added some code for ripemd-128 and ripemd-160 support
v1.04   * (08/18/01) - Added some code for sha-256 support
		     - Added rc info (properties)..
v1.15	* (08/21/01) - Added some code for sha-384 and sha-512 support
		     - Now read the command line
%

.486p                           	;486 instruction set enable
.model flat, stdCALL
include monwin32.inc                    ;mes constantes

VERIFYME = 1
include ../common/common.asm

;*******************************************************************
;*  DATA                                                           *
;*******************************************************************
	.data
         
lu48class_hInst	dd 0                    ;hInst

;/* Errors */
error_flag	dd 0			;0 = no error
error0		db "VerifyMe", 0
error1		db "Your checkme file is too big", 0
error2		db "Warning : file not found", 0
error3		db "CRC excepted. File truncated ?", 0
error4		db "Error : incorrect CRC32", 0
error5		db "No checkme files found !", 0
endmsg1		db "No error :) Everything is OK !", 0
endmsg2		db "Done :)", 0Dh,0Ah,"%d errors have been reported.", 0

	.data?
fichier_hwnd	dd ?			;hwnd of the "checkme" file
next_line	dd ?			;offset of the next line
lus		dd ?			;used by readfile

tempbuffer	db MAX_PATH dup(?)
MAX_CHECKME_FILE_SIZE = 255*255
checkmefilebuff	db MAX_CHECKME_FILE_SIZE dup(?)

;*******************************************************************
;*  CODE                                                           *
;*******************************************************************
         .code
;*******************************************************************
;* parse_line - read until 0Dh,0Ah			   	   *
;* (modify : eax and esi)					   *
;*******************************************************************
parse_line	proc
	mov	eax, next_line
on_recommence:
	mov	esi, eax
on_avance:
	cmp	byte ptr [eax], 00h
	jz	fini_avance2
	cmp	byte ptr [eax], 0Dh
	jz	fini_avance
	inc	eax
	jmp	on_avance
fini_avance:
	mov	byte ptr [eax], 0
	inc	eax			;skip 0Dh
	.if	(byte ptr [eax]==0Ah)
	 inc	eax			;skip 0Ah
	.endif
	cmp	byte ptr [esi], "/"
	jz	on_recommence
	mov	next_line, eax
	ret
fini_avance2:
	mov	eax, -1	
	ret
parse_line	endp

;*******************************************************************
;* read_with_commandline					   *
;*******************************************************************
read_with_commandline	proc
		uses	edi
		local	p:dword
		
	call	GetCommandLineA
	mov	esi, eax
	call	lstrlenA, eax
	mov	ecx, eax
	cmp	byte ptr [esi+eax-1], 20h
	jz	begin_checkmefile2

	.if (byte ptr [esi+eax-1]==22h)		;'"'
	 mov	byte ptr [esi+eax-1], 0
	.endif

scan_point:
	dec	eax
	cmp	byte ptr [esi+eax-1], "."
	jnz	scan_point
	push	eax
;
;find the good entry now !
;
	xor	edi, edi
	lea	eax, [esi+eax]
	mov	p, eax
	;
	call	lstrcmp, p, offset filename_crc32+filename_extension
	test	eax, eax
	jz	found_entry
	inc	edi
	call	lstrcmp, p, offset filename_md5+filename_extension
	test	eax, eax
	jz	found_entry
	inc	edi
	call	lstrcmp, p, offset filename_ripemd128+filename_extension
	test	eax, eax
	jz	found_entry
	inc	edi
	call	lstrcmp, p, offset filename_ripemd160+filename_extension
	test	eax, eax
	jz	found_entry
	inc	edi
	call	lstrcmp, p, offset filename_sha160+filename_extension
	test	eax, eax
	jz	found_entry
	inc	edi
	call	lstrcmp, p, offset filename_sha256+filename_extension
	test	eax, eax
	jz	found_entry
	inc	edi
	call	lstrcmp, p, offset filename_sha384+filename_extension
	test	eax, eax
	jz	found_entry
	inc	edi
	call	lstrcmp, p, offset filename_sha512+filename_extension
	test	eax, eax
	jz	found_entry
	;
	add	esp, 4
	jmp	begin_checkmefile2	;nothing found..
;
;Got-it !
;
found_entry:
	shl	edi, 4			;*10h
	add	edi, (offset crypt_table)
	mov	crypt_current, edi
;
; Now scan for a space.. and open the file
;
	pop	eax
scan_space:
	dec	eax
	cmp	byte ptr [esi+eax-1], 20h
	jnz	scan_space
	lea	eax, [esi+eax]

	.if(byte ptr [eax]==22h)
	 inc	eax
	.endif

	call	CreateFileA, eax, GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	cmp	eax, -1
	jz	begin_checkmefile2

	mov	fichier_hwnd, eax
	xor	eax, eax
	ret
begin_checkmefile2:
	mov	eax, -1
	ret
read_with_commandline	endp
;*******************************************************************
;* read_without_commandline					   *
;*******************************************************************
read_without_commandline	proc
	; Seek for checkme files : crc32, md5, ripemd128, ripemd160, sha160, sha256, sha384, sha512
	mov	esi, (offset crypt_table)-10h
lookup:
	add	esi, 10h		;next entry
	mov	eax, dword ptr [esi]
	test	eax, eax
	jz	begin_checkmefile
	call	CreateFileA, eax, GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	cmp	eax, -1
	jz	lookup

	mov	crypt_current, esi
	mov	fichier_hwnd, eax
	xor	eax, eax
	ret
begin_checkmefile:
	ret	;eax=-1
read_without_commandline	endp

;*******************************************************************
;* lookup_checkme - try to find "checkme" files			   *
;* ("checkme.crc32")						   *
;*******************************************************************
lookup_checkme	proc
		uses	esi
		local	temp_hwnd : dword
		local	temp_mapp : dword
		local	temp_pointer : dword

	call	read_with_commandline
	test	eax, eax
	jz	begin_parse
	call	read_without_commandline
	cmp	eax, -1	
	jz	nocheckmefile
;***
; Now parse the "checkme" file
;***
begin_parse:
	call	GetFileSize, fichier_hwnd, NULL
	cmp	eax, MAX_CHECKME_FILE_SIZE
	jg	error_nospace
	call	ReadFile, fichier_hwnd, offset checkmefilebuff, eax, offset lus, NULL

	mov	eax, offset checkmefilebuff
	mov	next_line, eax
;***
boucle_principale:
	call	parse_line
	cmp	eax, -1
	jz	end_boucle

	call	CreateFileA, esi, GENERIC_READ, NULL, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	mov	temp_hwnd, eax

	.if (eax==-1)
	 mov	ecx, esi
	 call	parse_line		;change esi
	 call	MessageBoxA, NULL, ecx, offset error2, MB_OKCANCEL
	 cmp	al, 2
	 jz	end_boucle
	.else
	 call	GetFileSize, temp_hwnd, NULL
	 push	eax
 	 call	CreateFileMappingA, temp_hwnd, NULL, PAGE_READONLY, NULL, NULL, NULL
	 mov	temp_mapp, eax
	 call	MapViewOfFile, eax, FILE_MAP_READ, 0, 0, 0
	 mov	temp_pointer, eax

	 call	parse_line
	 cmp	eax, -1
	 jz	error_crcexpected

	 call	HashBuffer, temp_pointer		;*** compute the crc (last arg [the size] is already on the stack)
	 call	lstrcmp, ecx, esi			;*** result: eax=true or false
	 push	eax
	 call	UnmapViewOfFile, temp_pointer
	 call	CloseHandle, temp_mapp
	 call	CloseHandle, temp_hwnd
	 pop	eax
	 test	eax, eax
	 jz	wrong_crc				;incorrect CRC ?
	 inc	dword ptr [error_flag]
	 call	MessageBoxA, NULL, esi, offset error4, MB_OKCANCEL
	 cmp	al, 2
	 jz	end_boucle	 
wrong_crc:
	.endif
;***
	jmp	boucle_principale
end_boucle:
	call	CloseHandle, fichier_hwnd
	mov	eax, error_flag
	.if (eax==0)
	 call	MessageBoxA, NULL, offset endmsg1, offset error0, MB_ICONINFORMATION
	.else
	 call	_wsprintfA, offset tempbuffer, offset endmsg2, eax
	 add	esp, 0Ch
	 call	MessageBoxA, NULL, offset tempbuffer, offset error0, MB_ICONINFORMATION
	.endif
	xor	eax, eax
nothing1:
	ret
error_crcexpected:
	call	UnmapViewOfFile, temp_pointer
	call	CloseHandle, temp_mapp
	call	CloseHandle, temp_hwnd
	call	MessageBox, NULL, offset error1, offset error3, MB_OK
	jmp	end_boucle
error_nospace:
	call	MessageBox, NULL, offset error1, offset error0, MB_OK
	jmp	end_boucle
nocheckmefile:	
	call	MessageBox, NULL, offset error5, offset error0, MB_ICONWARNING
	ret
lookup_checkme	endp

;*******************************************************************
; MAIN								   *
;*******************************************************************
main:                                   ;le code commence ici
	call	GetModuleHandle, NULL
	mov	[lu48class_hInst], eax

	call	lookup_checkme
	call	ExitProcess, NULL
;*******************************************************************

	end main			;end of code
